(function() {
  var DB, DeferredList, d, db, defer, entryCount, path, readCount, start, td, uuid;
  DB = require('../build/default/leveldb.node').DB;
  uuid = require('node-uuid');
  td = require("twisted-deferred");
  start = Date.now();
  entryCount = 1000;
  readCount = 0;
  defer = td.toDeferred;
  DeferredList = td.DeferredList;
  console.log("Creating test database");
  path = "/tmp/iterator.db";
  db = new DB();
  d = defer(db.open.bind(db), path, {
    create_if_missing: true
  });
  d.addCallback(function() {
    var deferreds, i, id, put_d;
    console.log('!! creating ' + entryCount + ' random key entries');
    deferreds = [];
    for (i = 0; 0 <= entryCount ? i <= entryCount : i >= entryCount; 0 <= entryCount ? i++ : i--) {
      id = uuid();
      put_d = defer(db.put.bind(db), id, JSON.stringify({
        id: id,
        name: 'Bob',
        age: 33
      }));
      deferreds.push(put_d);
    }
    return DeferredList(deferreds);
  });
  d.addCallback(function() {
    var iterator;
    console.log('created in ' + (Date.now() - start) + 'ms');
    console.log('!! iterating db in key order');
    start = Date.now();
    iterator = db.newIterator({});
    return iterator.seekToFirst(function() {
      var key, lastKey;
      console.log("asdf");
      return;
      while (iterator.valid()) {
        key = iterator.key().toString('utf8');
        if (lastKey && lastKey > key) {
          console.log('found sorting error');
        }
        lastKey = key;
        readCount++;
        iterator.next();
      }
      return console.log('read sequential ' + readCount + ' db contents in ' + (Date.now() - start) + 'ms');
    });
  });
  d.addCallback(function() {
    var deferred, iterator, testUUID;
    console.log('Start Seek test');
    deferred = new td.Deferred();
    iterator = db.newIterator({});
    testUUID = uuid();
    iterator.seek("" + testUUID, function() {
      console.log('looking for first key after: ' + testUUID);
      if (iterator.valid()) {
        console.log('FOUND: ' + iterator.key().toString('utf-8'));
      }
      return deferred.callback();
    });
    return deferred;
  });
  d.addCallback(function() {
    return console.log("Success");
  });
  d.addErrback(function(err) {
    return console.log(err.message.stack);
  });
  d.addBoth(function() {
    db.close();
    DB.destroyDB(path, {});
    return console.log("Database removed and cleaned up.");
  });
}).call(this);
